diff -urN memcached-1.4.13/memcached.c memcached-1.4.13-repcached-2.3.1/memcached.c
--- memcached-1.4.13/memcached.c	Sun Jan 29 02:37:59 2012
+++ memcached-1.4.13-repcached-2.3.1/memcached.c	Mon Feb 13 04:26:01 2012
@@ -5240,3 +5601,362 @@
 
     return retval;
 }
+
+#ifdef USE_REPLICATION
+static int replication_start(void)
+{
+    static int start = 0;
+    if(start)
+        return(0);
+
+    create_listening_sockets();
+
+    start = 1;
+    return(0);
+}
+
+static int replication_server_init(void)
+{
+    rep_recv = NULL;
+    rep_send = NULL;
+    rep_conn = NULL;
+    if(server_socket_replication(settings.rep_port)){
+        fprintf(stderr, "replication: failed to initialize replication server socket\n");
+        return(-1);
+    }
+    if (settings.verbose > 0)
+        fprintf(stderr, "replication: listen\n");
+    return(replication_start());
+}
+
+static int replication_client_init(void)
+{
+    int s;
+    conn *c;
+    struct addrinfo    ai;
+    struct sockaddr_in server;
+
+    rep_recv  = NULL;
+    rep_send  = NULL;
+    rep_conn  = NULL;
+
+    memset(&ai,0,sizeof(ai));
+    ai.ai_family   = AF_INET;
+    ai.ai_socktype = SOCK_STREAM;
+    s = new_socket(&ai);
+
+    if(s == -1) {
+        fprintf(stderr, "replication: failed to replication client socket\n");
+        return(-1);
+    }else{
+        /* connect */
+        memset((char *)&server, 0, sizeof(server));
+        server.sin_family = AF_INET;
+        server.sin_addr   = settings.rep_addr;
+        server.sin_port   = htons(settings.rep_port);
+        if (settings.verbose > 0)
+            fprintf(stderr,"replication: connect (peer=%s:%d)\n", inet_ntoa(settings.rep_addr), settings.rep_port);
+        if(connect(s,(struct sockaddr *)&server, sizeof(server)) == 0){
+            c = conn_new(s, conn_repconnect, EV_WRITE | EV_PERSIST, DATA_BUFFER_SIZE, false, main_base);
+            if(c == NULL){
+                fprintf(stderr, "replication: failed to create client conn");
+                close(s);
+                return(-1);
+            }
+            drive_machine(c);
+        }else{
+            if(errno == EINPROGRESS){
+                c = conn_new(s, conn_repconnect, EV_WRITE | EV_PERSIST, DATA_BUFFER_SIZE, false, main_base);
+                if(c == NULL){
+                    fprintf(stderr, "replication: failed to create client conn");
+                    close(s);
+                    return(-1);
+                }
+            }else{
+                fprintf(stdout,"replication: can't connect %s:%d\n", inet_ntoa(server.sin_addr), ntohs(server.sin_port));
+                close(s);
+                return(-1);
+            }
+        }
+    }
+    return(0);
+}
+
+static int replication_init(void)
+{
+    if(settings.rep_addr.s_addr != htonl(INADDR_ANY)){
+        if(replication_client_init() != -1){
+            return(0);
+        }
+    }
+    return(replication_server_init());
+}
+
+static int replication_connect(void)
+{
+    int f;
+    int p[2];
+
+    if(pipe(p) == -1){
+        fprintf(stderr, "replication: can't create pipe\n");
+        return(-1);
+    }else{
+        if((f = fcntl(p[0], F_GETFL, 0)) < 0 || fcntl(p[0], F_SETFL, f | O_NONBLOCK) < 0) {
+            fprintf(stderr, "replication: can't setting O_NONBLOCK pipe[0]\n");
+            return(-1);
+        }
+        if((f = fcntl(p[1], F_GETFL, 0)) < 0 || fcntl(p[1], F_SETFL, f | O_NONBLOCK) < 0) {
+            fprintf(stderr, "replication: can't setting O_NONBLOCK pipe[0]\n");
+            return(-1);
+        }
+        pthread_mutex_lock(&replication_pipe_lock);
+        rep_recv = conn_new(p[0], conn_pipe_recv, EV_READ | EV_PERSIST, DATA_BUFFER_SIZE, tcp_transport, main_base);
+        rep_send = conn_new(p[1], conn_pipe_send, EV_READ | EV_PERSIST, DATA_BUFFER_SIZE, tcp_transport, main_base);
+        event_del(&rep_send->event);
+        pthread_mutex_unlock(&replication_pipe_lock);
+    }
+    return(0);
+}
+
+static int replication_close(void)
+{
+    Q_ITEM *q;
+
+    if(settings.verbose > 0)
+        fprintf(stderr,"replication: close\n");
+    if(rep_recv){
+        conn_close(rep_recv);
+        rep_recv = NULL;
+    }
+    pthread_mutex_lock(&replication_pipe_lock);
+    if(rep_send){
+        conn_close(rep_send);
+        rep_send = NULL;
+        if (settings.verbose > 1)
+            fprintf(stderr,"replication: close send\n");
+    }
+    pthread_mutex_unlock(&replication_pipe_lock);
+    while ((q = replication_queue_pop()) != NULL) {
+        qi_free(q);
+    }
+    if (settings.verbose > 1) {
+        fprintf(stderr, "replication: qitem free %d items\n", qi_free_list());
+    }
+    if(rep_conn){
+        conn_close(rep_conn);
+        rep_conn = NULL;
+        if (settings.verbose > 1)
+            fprintf(stderr,"replication: close conn\n");
+    }
+    if(!rep_exit)
+        replication_server_init();
+    return(0);
+}
+
+static void replication_dispatch_close(void)
+{
+    if (settings.verbose > 1)
+        fprintf(stderr, "replication: dispatch close\n");
+    pthread_mutex_lock(&replication_pipe_lock);
+    if (rep_send) {
+        conn_close(rep_send);
+        rep_send = NULL;
+    }
+    pthread_mutex_unlock(&replication_pipe_lock);
+}
+
+static int replication_marugoto(int f)
+{
+    static int   keysend  = 0;
+    static int   keycount = 0;
+    static char *keylist  = NULL;
+    static char *keyptr   = NULL;
+
+    if(f){
+        if(keylist){
+            free(keylist);
+            keylist  = NULL;
+            keyptr   = NULL;
+            keycount = 0;
+            keysend  = 0;
+        }
+        pthread_mutex_lock(&cache_lock);
+        keylist = (char *)assoc_key_snap((int *)&keycount);
+        pthread_mutex_unlock(&cache_lock);
+        keyptr  = keylist;
+        if (!keyptr){
+            replication_call_marugoto_end();
+        }else{
+        if (settings.verbose > 0)
+            fprintf(stderr,"replication: marugoto start\n");
+        }
+    }else{
+        if(keyptr){
+            while(*keyptr){
+                item *it = item_get(keyptr, strlen(keyptr));
+                if(it){
+                    item_remove(it);
+                    if(replication_call_rep(keyptr, strlen(keyptr)) == -1){
+                        return(-1);
+                    }else{
+                        keysend++;
+                        keyptr += strlen(keyptr) + 1;
+                        return(0);
+                    }
+                }
+                keyptr += strlen(keyptr) + 1;
+            }
+            if(settings.verbose > 0)
+                fprintf(stderr,"replication: marugoto %d\n", keysend);
+            replication_call_marugoto_end();
+            if(settings.verbose > 0)
+                fprintf(stderr,"replication: marugoto owari\n");
+            free(keylist);
+            keylist  = NULL;
+            keyptr   = NULL;
+            keycount = 0;
+            keysend  = 0;
+        }
+    }
+    return(0);
+}
+
+static int replication_send(conn *c)
+{
+    int w;
+
+    w = write(c->sfd, c->wcurr, c->wbytes);
+
+    if (w == -1 && !(errno == EAGAIN || errno == EINTR)) {
+        fprintf(stderr,"replication: send error %d\n", errno);
+        replication_close();
+        return -1;
+    }
+
+    if (w > 0) {
+        c->wbytes -= w;
+        c->wcurr  += w;
+    }
+
+    if (c->wbytes < 1024 * 1024 && replication_pop()) {
+        replication_close();
+        return -1;
+    }
+
+    if (!update_event(c, (c->wbytes ? EV_WRITE : 0) | EV_READ | EV_PERSIST)) {
+        fprintf(stderr, "replication: couldn't update event\n");
+        replication_close();
+        return -1;
+    }
+
+    if (rep_exit && c->wbytes == 0) {
+        replication_close();
+        if (settings.verbose)
+            fprintf(stderr,"replication: cleanup complete\n");
+        exit(EXIT_SUCCESS);
+    }
+
+    return 0;
+}
+
+static int replication_pop(void)
+{
+    int      r;
+    Q_ITEM  *q;
+
+    if (settings.verbose > 1)
+        fprintf(stderr, "replication: pop\n");
+
+    if (!rep_recv)
+        return 0;
+
+    r = read(rep_recv->sfd, rep_recv->rbuf, rep_recv->rsize);
+
+    if (r == -1 && !(errno == EAGAIN || errno == EINTR)) {
+        fprintf(stderr, "replication: pop error %d\n", errno);
+        return -1;
+    }
+    if (r == 0) {
+        /* other end closed, trigger replication_close() */
+        return -1;
+    }
+
+    /* process queue */
+
+    while (rep_conn->wbytes < 1024 * 1024 &&
+           (q = replication_queue_pop()) != NULL)
+    {
+        if (replication_cmd(rep_conn, q)) {
+            return -1;
+        }
+
+        qi_free(q);
+    }
+
+    if (rep_conn->wbytes < 1024 * 1024) {
+        replication_marugoto(0);
+    }
+
+    return 0;
+}
+
+static int replication_exit(void)
+{
+    rep_exit = 1;
+    return(replication_item(NULL));
+}
+
+static int replication_item(Q_ITEM *q)
+{
+    int w;
+
+    pthread_mutex_lock(&replication_pipe_lock);
+    if (!rep_send) {
+        qi_free(q);
+        pthread_mutex_unlock(&replication_pipe_lock);
+        return 0;
+    }
+
+    /* add item to queue */
+
+    if (q) {
+        replication_queue_push(q);
+    }
+
+    /* notify main thread we have more data */
+
+    w = write(rep_send->sfd, "", 1);
+
+    if (w == -1 && !(errno == EAGAIN || errno == EINTR)) {
+        fprintf(stderr,"replication: pipe write error %d\n", errno);
+        qi_free(q);
+        pthread_mutex_unlock(&replication_pipe_lock);
+        replication_dispatch_close();
+        return -1;
+    }
+
+    pthread_mutex_unlock(&replication_pipe_lock);
+    return 0;
+}
+
+int replication(enum CMD_TYPE type, R_CMD *cmd)
+{
+    Q_ITEM *q;
+
+    pthread_mutex_lock(&replication_pipe_lock);
+    if (!rep_send) {
+        pthread_mutex_unlock(&replication_pipe_lock);
+        return 0;
+    }
+    pthread_mutex_unlock(&replication_pipe_lock);
+
+    if((q = qi_new(type, cmd, false))) {
+        replication_item(q);
+    }else{
+        fprintf(stderr,"replication: can't create Q_ITEM\n");
+        replication_dispatch_close();
+        return(-1);
+    }
+    return(0);
+}
+#endif /* USE_REPLICATION */
diff -urN memcached-1.4.13/memcached.h memcached-1.4.13-repcached-2.3.1/memcached.h
--- memcached-1.4.13/memcached.h	Wed Jan 11 03:09:09 2012
+++ memcached-1.4.13-repcached-2.3.1/memcached.h	Mon Feb 13 01:14:16 2012
@@ -151,6 +151,12 @@
     conn_swallow,    /**< swallowing unnecessary bytes w/o storing */
     conn_closing,    /**< closing this connection */
     conn_mwrite,     /**< writing out many items sequentially */
+#ifdef USE_REPLICATION
+    conn_repconnect, /**< replication connecting to master */
+    conn_rep_listen, /**< replication listening socket */
+    conn_pipe_recv,  /**< replication command pipe recv */
+    conn_pipe_send,  /**< replication command pipe send */
+#endif /* USE_REPLICATION */
     conn_max_state   /**< Max state value (used for assertion) */
 };
 
@@ -303,6 +309,11 @@
     bool slab_reassign;     /* Whether or not slab reassignment is allowed */
     bool slab_automove;     /* Whether or not to automatically move slabs */
     int hashpower_init;     /* Starting hash power level */
+#ifdef USE_REPLICATION
+    struct in_addr rep_addr;    /* replication addr */
+    int rep_port;               /* replication port */
+    int rep_qmax;               /* replication QITEM max */
+#endif /*USE_REPLICATION*/
 };
 
 extern struct stats stats;
@@ -317,6 +328,10 @@
 
 #define ITEM_FETCHED 8
 
+#ifdef USE_REPLICATION
+#define ITEM_REPDATA 128
+#endif /*USE_REPLICATION*/
+
 /**
  * Structure for storing items within memcached.
  */
@@ -498,6 +513,10 @@
 #include "trace.h"
 #include "hash.h"
 #include "util.h"
+
+#ifdef USE_REPLICATION
+#include "replication.h"
+#endif /* USE_REPLICATION */
 
 /*
  * Functions such as the libevent-related calls that need to do cross-thread
diff -urN memcached-1.4.13/replication.c memcached-1.4.13-repcached-2.3.1/replication.c
--- memcached-1.4.13/replication.c	Thu Jan  1 03:00:00 1970
+++ memcached-1.4.13-repcached-2.3.1/replication.c	Mon Feb 13 01:13:58 2012
@@ -0,0 +1,383 @@
+/* -*- Mode: C; tab-width: 4; c-basic-offset: 4; indent-tabs-mode: nil -*- */
+/*
+ *
+ */
+#include "memcached.h"
+#include "replication.h"
+#include <stdlib.h>
+#include <stdio.h>
+#include <unistd.h>
+#include <string.h>
+#include <errno.h>
+
+static Q_ITEM *q_head      = NULL;
+static Q_ITEM *q_tail      = NULL;
+static Q_ITEM *q_freelist  = NULL;
+static int     q_itemcount = 0;
+static pthread_mutex_t replication_queue_lock = PTHREAD_MUTEX_INITIALIZER;
+
+int get_qi_count(void)
+{
+    int c;
+    pthread_mutex_lock(&replication_queue_lock);
+    c = q_itemcount;
+    pthread_mutex_unlock(&replication_queue_lock);
+    return(c);
+}
+
+Q_ITEM *qi_new(enum CMD_TYPE type, R_CMD *cmd, bool reuse)
+{
+    Q_ITEM     *q      = NULL;
+    char       *key    = NULL;
+    uint32_t    keylen = 0;
+    rel_time_t  time   = 0;
+
+    pthread_mutex_lock(&replication_queue_lock);
+    if(q_freelist){
+        q = q_freelist;
+        q_freelist = q->next;
+    }
+
+    if(NULL == q){
+        if(reuse) {
+            pthread_mutex_unlock(&replication_queue_lock);
+            return(NULL);
+        }
+        if(q_itemcount >= settings.rep_qmax) {
+            pthread_mutex_unlock(&replication_queue_lock);
+            return(NULL);
+        }
+        q = malloc(sizeof(Q_ITEM));
+        if (NULL == q){
+            fprintf(stderr,"replication: qi_new out of memory\n");
+            pthread_mutex_unlock(&replication_queue_lock);
+            return(NULL);
+        }
+        q_itemcount++;
+        if (settings.verbose > 2)
+            fprintf(stderr,"replication: alloc c=%d\n", q_itemcount);
+    }
+
+    pthread_mutex_unlock(&replication_queue_lock);
+
+    switch (type) {
+    case REPLICATION_REP:
+    case REPLICATION_DEL:
+        key    = cmd->key;
+        keylen = cmd->keylen;
+        break;
+    case REPLICATION_FLUSH_ALL:
+        break;
+    case REPLICATION_DEFER_FLUSH_ALL:
+        time   = cmd->time;
+        break;
+    case REPLICATION_MARUGOTO_END:
+        break;
+    default:
+        fprintf(stderr,"replication: got unknown command: %d\n", type);
+        return(NULL);
+    }
+
+    q->key  = NULL;
+    q->type = type;
+    q->time = time;
+    q->next = NULL;
+    if (keylen) {
+        q->key = malloc(keylen + 1);
+        if(NULL == q->key){
+            qi_free(q);
+            q = NULL;
+        }else{
+            memcpy(q->key, key, keylen);
+            *(q->key + keylen) = 0;
+        }
+    }
+
+    return(q);
+}
+
+void qi_free(Q_ITEM *q)
+{
+    if(q){
+        if(q->key){
+            free(q->key);
+            q->key = NULL;
+        }
+        pthread_mutex_lock(&replication_queue_lock);
+        q->next = q_freelist;
+        q_freelist = q;
+        pthread_mutex_unlock(&replication_queue_lock);
+    }
+}
+
+int qi_free_list()
+{
+    int     c = 0;
+    Q_ITEM *q = NULL;
+
+    pthread_mutex_lock(&replication_queue_lock);
+    while((q = q_freelist)){
+        q_itemcount--;
+        c++;
+        q_freelist = q->next;
+        free(q);
+    }
+    pthread_mutex_unlock(&replication_queue_lock);
+    return(c);
+}
+
+void replication_queue_push(Q_ITEM *q)
+{
+    pthread_mutex_lock(&replication_queue_lock);
+    if (q_tail != NULL) {
+        q_tail->next = q;
+    } else {
+        q_head = q;
+    }
+    q_tail = q;
+    q->next = NULL;
+    pthread_mutex_unlock(&replication_queue_lock);
+}
+
+Q_ITEM *replication_queue_pop(void)
+{
+    Q_ITEM *q;
+
+    pthread_mutex_lock(&replication_queue_lock);
+    q = q_head;
+    if (q != NULL) {
+        q_head = q->next;
+        if (q->next == NULL) {
+            q_tail = NULL;
+        }
+    }
+    pthread_mutex_unlock(&replication_queue_lock);
+    return q;
+}
+
+static int replication_get_num(char *p, int n)
+{
+    int  l;
+    char b[64];
+    if(p)
+        l = sprintf(p, "%u", n);
+    else
+        l = sprintf(b, "%u", n);
+    return(l);
+}
+
+int replication_call_rep(char *key, size_t keylen)
+{
+    R_CMD r;
+    r.key    = key;
+    r.keylen = keylen;
+    return(replication(REPLICATION_REP, &r));
+}
+
+int replication_call_del(char *key, size_t keylen)
+{
+    R_CMD r;
+    r.key    = key;
+    r.keylen = keylen;
+    return(replication(REPLICATION_DEL, &r));
+}
+
+int replication_call_flush_all()
+{
+    R_CMD r;
+    r.key = NULL;
+    return(replication(REPLICATION_FLUSH_ALL, &r));
+}
+
+int replication_call_defer_flush_all(const rel_time_t time)
+{
+    R_CMD r;
+    r.key  = NULL;
+    r.time = time;
+    return(replication(REPLICATION_DEFER_FLUSH_ALL, &r));
+}
+
+int replication_call_marugoto_end()
+{
+    R_CMD r;
+    r.key = NULL;
+    return(replication(REPLICATION_MARUGOTO_END, &r));
+}
+
+static int replication_alloc(conn *c, int s)
+{
+    char *p;
+    s += c->wbytes;
+    if(c->wsize < s + (c->wcurr - c->wbuf)){
+        while(c->wsize < s)
+            c->wsize += 4096;
+        if((p = malloc(c->wsize))){
+            memcpy(p, c->wcurr, c->wbytes);
+            free(c->wbuf);
+            c->wbuf = p;
+            c->wcurr = p;
+        }else{
+            return(-1);
+        }
+    }
+    return(0);
+}
+
+static int replication_del(conn *c, char *k)
+{
+    int   l = 0;
+    char *s = "delete ";
+    char *n = "\r\n";
+    char *p = NULL;
+
+    l += strlen(s);
+    l += strlen(k);
+    l += strlen(n);
+    if(replication_alloc(c,l) == -1){
+        fprintf(stderr, "replication: del malloc error\n");
+        return(-1);
+    }
+    p = c->wcurr + c->wbytes;
+    memcpy(p, s, strlen(s));
+    p += strlen(s);
+    memcpy(p, k, strlen(k));
+    p += strlen(k);
+    memcpy(p, n, strlen(n));
+    p += strlen(n);
+    c->wbytes = p - c->wcurr;
+    return(0);
+}
+
+static int replication_rep(conn *c, item *it)
+{
+    int exp = 0;
+    int len = 0;
+    char *s = "rep ";
+    char *n = "\r\n";
+    char *p = NULL;
+    char flag[40];
+
+    if(it->exptime)
+        exp = it->exptime + process_started;
+    flag[0]=0;
+    if((p=ITEM_suffix(it))){
+        int i;
+        memcpy(flag, p, it->nsuffix - 2);
+        flag[it->nsuffix - 2] = 0;
+        for(i=0;i<strlen(flag);i++){
+            if(flag[i] > ' ')
+                break;
+        }
+        memmove(flag,&flag[i],strlen(flag)-i);
+        for(p=flag;*p>' ';p++);
+        *p=0;
+    }
+    len += strlen(s);
+    len += it->nkey;
+    len += 1;
+    len += strlen(flag);
+    len += 1;
+    len += replication_get_num(NULL, exp);
+    len += 1;
+    len += replication_get_num(NULL, it->nbytes - 2);
+    len += 1;
+    len += replication_get_num(NULL, ITEM_get_cas(it));
+    len += strlen(n);
+    len += it->nbytes;
+    len += strlen(n);
+    if(replication_alloc(c,len) == -1){
+        fprintf(stderr, "replication: rep malloc error\n");
+        return(-1);
+    }
+    p = c->wcurr + c->wbytes;
+    memcpy(p, s, strlen(s));
+    p += strlen(s);
+    memcpy(p, ITEM_key(it), it->nkey);
+    p += it->nkey;
+    *(p++) = ' ';
+    memcpy(p, flag, strlen(flag));
+    p += strlen(flag);
+    *(p++) = ' ';
+    p += replication_get_num(p, exp);
+    *(p++) = ' ';
+    p += replication_get_num(p, it->nbytes - 2);
+    *(p++) = ' ';
+    p += replication_get_num(p, ITEM_get_cas(it));
+    memcpy(p, n, strlen(n));
+    p += strlen(n);
+    memcpy(p, ITEM_data(it), it->nbytes);
+    p += it->nbytes;
+    c->wbytes = p - c->wcurr;
+    return(0);
+}
+
+static int replication_flush_all(conn *c, rel_time_t exp)
+{
+    char *s = "flush_all ";
+    char *n = "\r\n";
+    char *p = NULL;
+
+    int l = strlen(s) + strlen(n);
+    if (exp > 0)
+        l += replication_get_num(NULL, exp);
+    if(replication_alloc(c,l) == -1){
+        fprintf(stderr, "replication: flush_all malloc error\n");
+        return(-1);
+    }
+    p = c->wcurr + c->wbytes;
+    memcpy(p, s, strlen(s));
+    p += strlen(s);
+    if (exp > 0)
+        p += replication_get_num(p, exp);
+    memcpy(p, n, strlen(n));
+    p += strlen(n);
+    c->wbytes = p - c->wcurr;
+    return(0);
+}
+
+static int replication_marugoto_end(conn *c)
+{
+    char *s = "marugoto_end";
+    char *n = "\r\n";
+    char *p = NULL;
+
+    int l = strlen(s) + strlen(n);
+    if(replication_alloc(c,l) == -1){
+        fprintf(stderr, "replication: marugoto_end malloc error\n");
+        return(-1);
+    }
+    p = c->wcurr + c->wbytes;
+    memcpy(p, s, strlen(s));
+    p += strlen(s);
+    memcpy(p, n, strlen(n));
+    p += strlen(n);
+    c->wbytes = p - c->wcurr;
+    return(0);
+}
+
+int replication_cmd(conn *c, Q_ITEM *q)
+{
+    item *it;
+    int r;
+
+    switch (q->type) {
+    case REPLICATION_REP:
+        it = item_get(q->key, strlen(q->key));
+        if (!it)
+            return(replication_del(c, q->key));
+        r = replication_rep(c, it);
+        item_remove(it);
+        return r;
+    case REPLICATION_DEL:
+        return(replication_del(c, q->key));
+    case REPLICATION_FLUSH_ALL:
+        return(replication_flush_all(c, 0));
+    case REPLICATION_DEFER_FLUSH_ALL:
+        return(replication_flush_all(c, q->time));
+    case REPLICATION_MARUGOTO_END:
+        return(replication_marugoto_end(c));
+    default:
+        fprintf(stderr,"replication: got unknown command:%d\n", q->type);
+        return(0);
+    }
+}
diff -urN memcached-1.4.13/replication.h memcached-1.4.13-repcached-2.3.1/replication.h
--- memcached-1.4.13/replication.h	Thu Jan  1 03:00:00 1970
+++ memcached-1.4.13-repcached-2.3.1/replication.h	Mon Feb 13 01:13:58 2012
@@ -0,0 +1,45 @@
+#ifndef MEMCACHED_REPLICATION_H
+#define MEMCACHED_REPLICATION_H
+#define REPCACHED_VERSION "2.3.1"
+#include <netdb.h>
+
+enum CMD_TYPE {
+  REPLICATION_REP,
+  REPLICATION_DEL,
+  REPLICATION_FLUSH_ALL,
+  REPLICATION_DEFER_FLUSH_ALL,
+  REPLICATION_MARUGOTO_END,
+};
+
+typedef struct queue_item_t Q_ITEM;
+struct queue_item_t {
+  enum CMD_TYPE  type;
+  char          *key;
+  rel_time_t     time;
+  Q_ITEM        *next;
+};
+
+typedef struct replication_cmd_t R_CMD;
+struct replication_cmd_t {
+  char       *key;
+  int         keylen;
+  rel_time_t  time;
+};
+
+Q_ITEM *qi_new(enum CMD_TYPE type, R_CMD *cmd, bool);
+void    qi_free(Q_ITEM *);
+int     qi_free_list(void);
+int     replication_cmd(conn *, Q_ITEM *);
+int     get_qi_count(void);
+
+void    replication_queue_push(Q_ITEM *);
+Q_ITEM *replication_queue_pop(void);
+
+int replication_call_rep(char *key, size_t keylen);
+int replication_call_del(char *key, size_t keylen);
+int replication_call_flush_all(void);
+int replication_call_defer_flush_all(const rel_time_t time);
+int replication_call_marugoto_end(void);
+int replication(enum CMD_TYPE type, R_CMD *cmd);
+
+#endif
diff -urN memcached-1.4.13/t/binary.t memcached-1.4.13-repcached-2.3.1/t/binary.t
--- memcached-1.4.13/t/binary.t	Thu Jan 26 10:56:02 2012
+++ memcached-1.4.13-repcached-2.3.1/t/binary.t	Mon Feb 13 01:16:42 2012
@@ -2,10 +2,12 @@
 
 use strict;
 use warnings;
-use Test::More tests => 3539;
+use Test::More;
 use FindBin qw($Bin);
 use lib "$Bin/lib";
 use MemcachedTest;
+
+Test::More::plan(tests => 3539 + (support_replication() ? 36 : 0));
 
 my $server = new_memcached();
 ok($server, "started the server");
diff -urN memcached-1.4.13/t/issue_67.t memcached-1.4.13-repcached-2.3.1/t/issue_67.t
--- memcached-1.4.13/t/issue_67.t	Fri Jan  6 22:19:50 2012
+++ memcached-1.4.13-repcached-2.3.1/t/issue_67.t	Mon Feb 13 01:13:58 2012
@@ -41,6 +41,10 @@
     my $exe = "$builddir/memcached-debug";
     croak("memcached binary doesn't exist.  Haven't run 'make' ?\n") unless -e $exe;
 
+    if (support_replication()) {
+        $args .= ' -X 0';
+    }
+
     my $childpid = fork();
 
     my $root = '';
diff -urN memcached-1.4.13/t/lib/MemcachedTest.pm memcached-1.4.13-repcached-2.3.1/t/lib/MemcachedTest.pm
--- memcached-1.4.13/t/lib/MemcachedTest.pm	Fri Jan  6 22:19:50 2012
+++ memcached-1.4.13-repcached-2.3.1/t/lib/MemcachedTest.pm	Mon Feb 13 01:13:58 2012
@@ -13,7 +13,8 @@
 
 
 @EXPORT = qw(new_memcached sleep mem_get_is mem_gets mem_gets_is mem_stats
-             supports_sasl free_port);
+             supports_sasl free_port support_replication memcached_version
+             version2num);
 
 sub sleep {
     my $n = shift;
@@ -148,6 +149,23 @@
     return 0;
 }
 
+sub support_replication {
+    my $output = `$builddir/memcached-debug -h`;
+    return 1 if $output =~ /^-x <ip_addr>/m;
+    return 0;
+}
+
+sub memcached_version {
+    my $output = `$builddir/memcached-debug -h`;
+    return $1 if $output =~ /^memcached (\d[\d\.]+)/;
+    return 0;
+}
+
+sub version2num {
+    my($major,$minor,$pl) = ($_[0] =~ /^(\d+)\.(\d+)\.(\d+)$/);
+    return $major*100**2 + $minor*100 + $pl
+}
+
 sub new_memcached {
     my ($args, $passed_port) = @_;
     my $port = $passed_port || free_port();
@@ -171,6 +189,9 @@
     }
     if ($< == 0) {
         $args .= " -u root";
+    }
+    if (support_replication() && $args !~ m/-X/) {
+        $args .= ' -X 0';
     }
 
     my $childpid = fork();
diff -urN memcached-1.4.13/t/stats.t memcached-1.4.13-repcached-2.3.1/t/stats.t
--- memcached-1.4.13/t/stats.t	Fri Jan  6 22:19:50 2012
+++ memcached-1.4.13-repcached-2.3.1/t/stats.t	Mon Feb 13 01:13:58 2012
@@ -58,7 +58,8 @@
 my $stats = mem_stats($sock);
 
 # Test number of keys
-is(scalar(keys(%$stats)), 48, "48 stats values");
+is(scalar(keys(%$stats)), 48 + (support_replication() ? 3 : 0),
+   "number of stats values");
 
 # Test initial state
 foreach my $key (qw(curr_items total_items bytes cmd_get cmd_set get_hits evictions get_misses
diff -urN memcached-1.4.13/t.rep/00-startup.t memcached-1.4.13-repcached-2.3.1/t.rep/00-startup.t
--- memcached-1.4.13/t.rep/00-startup.t	Thu Jan  1 03:00:00 1970
+++ memcached-1.4.13-repcached-2.3.1/t.rep/00-startup.t	Mon Feb 13 05:07:52 2012
@@ -0,0 +1,12 @@
+#!/usr/bin/perl
+
+use strict;
+use Test::More qw(no_plan);
+use FindBin qw($Bin);
+use lib ("$Bin/lib", "$Bin/../t/lib");
+use RepcachedTest;
+
+my($m,$b) = new_repcached();
+ok($m, "started the master");
+ok($b, "started the backup");
+
diff -urN memcached-1.4.13/t.rep/11-set.t memcached-1.4.13-repcached-2.3.1/t.rep/11-set.t
--- memcached-1.4.13/t.rep/11-set.t	Thu Jan  1 03:00:00 1970
+++ memcached-1.4.13-repcached-2.3.1/t.rep/11-set.t	Mon Feb 13 05:07:52 2012
@@ -0,0 +1,22 @@
+#!/usr/bin/perl
+
+use strict;
+use Test::More qw(no_plan);
+use FindBin qw($Bin);
+use lib ("$Bin/lib", "$Bin/../t/lib");
+use RepcachedTest;
+
+my($m1, $m2) = new_repcached();
+my($sock_m1, $sock_m2) = ($m1->sock, $m2->sock);
+
+for my $sock ([$sock_m1, $sock_m2], [$sock_m2, $sock_m1]) {
+    my($sock_m, $sock_b) = ($sock->[0], $sock->[1]);
+
+    my $uniq = int(rand()*100000);
+    my($key, $val) = ('settest'.$uniq, 'setval'.$uniq);
+    my $vallen = length $val;
+
+    print $sock_m "set $key 0 0 $vallen\r\n$val\r\n";
+    is(scalar <$sock_m>, "STORED\r\n", "stored");
+    sync_get_is($sock_m, $sock_b, $key, $val);
+}
diff -urN memcached-1.4.13/t.rep/12-add.t memcached-1.4.13-repcached-2.3.1/t.rep/12-add.t
--- memcached-1.4.13/t.rep/12-add.t	Thu Jan  1 03:00:00 1970
+++ memcached-1.4.13-repcached-2.3.1/t.rep/12-add.t	Mon Feb 13 05:07:52 2012
@@ -0,0 +1,29 @@
+#!/usr/bin/perl
+
+use strict;
+use Test::More qw(no_plan);
+use FindBin qw($Bin);
+use lib ("$Bin/lib", "$Bin/../t/lib");
+use RepcachedTest;
+
+my($m1,$m2) = new_repcached();
+my($sock_m1, $sock_m2) = ($m1->sock, $m2->sock);
+
+for my $sock ([$sock_m1, $sock_m2], [$sock_m2, $sock_m1]) {
+    my($sock_m, $sock_b) = ($sock->[0], $sock->[1]);
+
+    my $uniq = int(rand()*100000);
+    my($key, $val) = ('addtest'.$uniq, 'addval'.$uniq);
+    my $vallen = length $val;
+
+    print $sock_m "add $key 0 0 $vallen\r\n$val\r\n";
+    is(scalar <$sock_m>, "STORED\r\n", "stored");
+    sync_get_is($sock_m, $sock_b, $key, $val);
+
+    my $val2    = 'addval2'.$uniq;
+    my $vallen2 = length $val2;
+
+    print $sock_m "add $key 0 0 $vallen2\r\n$val2\r\n";
+    is(scalar <$sock_m>, "NOT_STORED\r\n", "not stored");
+    sync_get_is($sock_m, $sock_b, $key, $val); # not $val2
+}
diff -urN memcached-1.4.13/t.rep/13-replace.t memcached-1.4.13-repcached-2.3.1/t.rep/13-replace.t
--- memcached-1.4.13/t.rep/13-replace.t	Thu Jan  1 03:00:00 1970
+++ memcached-1.4.13-repcached-2.3.1/t.rep/13-replace.t	Mon Feb 13 05:07:52 2012
@@ -0,0 +1,31 @@
+#!/usr/bin/perl
+
+use strict;
+use Test::More qw(no_plan);
+use FindBin qw($Bin);
+use lib ("$Bin/lib", "$Bin/../t/lib");
+use RepcachedTest;
+
+my($m1, $m2) = new_repcached();
+my($sock_m1, $sock_m2) = ($m1->sock, $m2->sock);
+
+for my $sock ([$sock_m1, $sock_m2], [$sock_m2, $sock_m1]) {
+    my($sock_m, $sock_b) = ($sock->[0], $sock->[1]);
+
+    my $uniq = int(rand()*100000);
+    my($key, $val) = ('replacetest'.$uniq, 'replaceval'.$uniq);
+    my $vallen = length $val;
+
+    print $sock_m "replace $key 0 0 $vallen\r\n$val\r\n";
+    is(scalar <$sock_m>, "NOT_STORED\r\n", "not stored");
+
+    my $val2    = 'setval_replace'.$$;
+    my $vallen2 = length $val2;
+    print $sock_m "set $key 0 0 $vallen2\r\n$val2\r\n";
+    is(scalar <$sock_m>, "STORED\r\n", "stored");
+    sync_get_is($sock_m, $sock_b, $key, $val2);
+
+    print $sock_m "replace $key 0 0 $vallen\r\n$val\r\n";
+    is(scalar <$sock_m>, "STORED\r\n", "stored");
+    sync_get_is($sock_m, $sock_b, $key, $val);
+}
diff -urN memcached-1.4.13/t.rep/21-set-exptime.t memcached-1.4.13-repcached-2.3.1/t.rep/21-set-exptime.t
--- memcached-1.4.13/t.rep/21-set-exptime.t	Thu Jan  1 03:00:00 1970
+++ memcached-1.4.13-repcached-2.3.1/t.rep/21-set-exptime.t	Mon Feb 13 05:07:52 2012
@@ -0,0 +1,26 @@
+#!/usr/bin/perl
+
+use strict;
+use Test::More qw(no_plan);
+use FindBin qw($Bin);
+use lib ("$Bin/lib", "$Bin/../t/lib");
+use RepcachedTest;
+
+my($m1, $m2) = new_repcached();
+my($sock_m1, $sock_m2) = ($m1->sock, $m2->sock);
+
+for my $sock ([$sock_m1, $sock_m2], [$sock_m2, $sock_m1]) {
+    my($sock_m, $sock_b) = ($sock->[0], $sock->[1]);
+
+    my $uniq = int(rand()*100000);
+    my($key, $val) = ('settest'.$uniq, 'setval'.$uniq);
+    my $vallen = length $val;
+
+    my $exptime = 3;
+
+    print $sock_m "set $key 0 $exptime $vallen\r\n$val\r\n";
+    is(scalar <$sock_m>, "STORED\r\n", "stored");
+    sync_get_is($sock_m, $sock_b, $key, $val);
+    sleep $exptime+1;
+    sync_get_is($sock_m, $sock_b, $key, undef)
+}
diff -urN memcached-1.4.13/t.rep/22-add-exptime.t memcached-1.4.13-repcached-2.3.1/t.rep/22-add-exptime.t
--- memcached-1.4.13/t.rep/22-add-exptime.t	Thu Jan  1 03:00:00 1970
+++ memcached-1.4.13-repcached-2.3.1/t.rep/22-add-exptime.t	Mon Feb 13 05:07:52 2012
@@ -0,0 +1,26 @@
+#!/usr/bin/perl
+
+use strict;
+use Test::More qw(no_plan);
+use FindBin qw($Bin);
+use lib ("$Bin/lib", "$Bin/../t/lib");
+use RepcachedTest;
+
+my($m1, $m2) = new_repcached();
+my($sock_m1, $sock_m2) = ($m1->sock, $m2->sock);
+
+for my $sock ([$sock_m1, $sock_m2], [$sock_m2, $sock_m1]) {
+    my($sock_m, $sock_b) = ($sock->[0], $sock->[1]);
+
+    my $uniq = int(rand()*100000);
+    my($key, $val) = ('addtest'.$uniq, 'addval'.$uniq);
+    my $vallen = length $val;
+
+    my $exptime = 3;
+
+    print $sock_m "add $key 0 $exptime $vallen\r\n$val\r\n";
+    is(scalar <$sock_m>, "STORED\r\n", "stored");
+    sync_get_is($sock_m, $sock_b, $key, $val);
+    sleep $exptime+1;
+    sync_get_is($sock_m, $sock_b, $key, undef)
+}
